<?php
/**
 * @version		$Id: edition.php,v 1.53 2010/01/19 17:46:47 juanca Exp $
 * @package		vpl. submission edition
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

global $CFG;
require_once dirname(__FILE__).'/../../../config.php';
require_once $CFG->libdir.'/formslib.php';
require_once $CFG->libdir.'/moodlelib.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
require_once dirname(__FILE__).'/../editor/editor_utility.php';
require_once dirname(__FILE__).'/form.class.php';
global $CFG;
class mod_vpl_editor_form extends vpl_form {
	protected $vpl;
	protected $instance;
	function __construct($page,$vpl){
		$this->vpl = $vpl;
		$this->instance = $vpl->get_instance();
		parent::__construct($page,'mform1');
	}

	function normalize_filelist($requiredfilelist,$filelist){
		return array_values(array_unique(array_merge($requiredfilelist,$filelist)));
	}

	function definition(){
		global $USER;
		$this->vpl->require_capability(VPL_SUBMIT_CAPABILITY);
		$id = required_param('id',PARAM_INT);
		$userid = optional_param('userid',null,PARAM_INT);
		$this->addHidden('id',$id);
		if($userid){
			$this->addHidden('userid',$userid);
			$lastsub = $this->vpl->last_user_submission($userid);
		}
		else{
			$userid = $USER->id;
			$lastsub = $this->vpl->last_user_submission($userid);
		}
		$htmlReadFiles = 'onclick="setETarget();return readFiles();"';
		$htmlAlertFilesChanged = 'onclick="setETarget();return alertFilesChanged();"';
		$instance = $this->vpl->get_instance();
		$this->addHTML('<div style="text-align: center">');
		$this->addSubmitButton('save',get_string('save',VPL),$htmlReadFiles);
		$manager = $this->vpl->has_capability(VPL_MANAGE_CAPABILITY);
		if($instance->run || $manager){
			$text = get_string('run',VPL);
			if(!$instance->run){
				$text = '('.$text.')';
			}
			$this->addSubmitButton('run',$text,$htmlAlertFilesChanged);
		}
		if($instance->debug || $manager){
			$text = get_string('debug',VPL);
			if(!$instance->debug){
				$text = '('.$text.')';
			}
			$this->addSubmitButton('debug',$text,$htmlAlertFilesChanged);
		}
		if($instance->evaluate || $manager){
			$text = get_string('evaluate',VPL);
			if(!$instance->evaluate){
				$text = '('.$text.')';
			}
			$this->addSubmitButton('evaluate',$text,$htmlAlertFilesChanged);
		}
		$linkScreen = vpl_rel_url('edition.php','id', $id,'userid',$userid);
		if(optional_param('fullscreen',0,PARAM_INT)){
	    	$screenText = get_string('regularscreen',VPL);		
		}else{
			$linkScreen = vpl_url_add_param($linkScreen,'fullscreen','1');
	    	$screenText = get_string('fullscreen',VPL);		
		}
		$this->addHTML('&nbsp;<a href="'.$linkScreen.'">'.s($screenText).'</a>');
		$this->addHTML('</div>');
		//Generate editor
		$param_tags='';
		$req_fgm = $this->vpl->get_required_fgm();
		$req_filelist =$req_fgm->getFileList();
		if($lastsub){
			$submission = new mod_vpl_submission($this->vpl, $lastsub);
			$fgp =  $submission->get_submitted_fgm();
			$filelist = $this->normalize_filelist($req_filelist,$fgp->getFileList());
			$param_tags .= $submission->get_CE_parms();
		}else{
			$fgp =  $req_fgm;
			$filelist = $fgp->getFileList();
		}
		$nodisplay='style="display:none"';
		$max = $this->instance->maxfiles;
		$nf = count($filelist);
		for( $i = 0; $i < $max; $i++){
			$field_filename = 'filename'.$i;
			$field_filedata = 'filedata'.$i;
			if($i< $nf){
				$filename=$filelist[$i];
				$filedata=$fgp->getFileData($filelist[$i]);
				//TODO urlencode only onces
				$this->addHidden($field_filename,$filename);
				$this->addHidden($field_filedata,urlencode($filedata));
				$param_tags .= vpl_param_tag($field_filename,$filename);
				$param_tags .= vpl_param_tag($field_filedata,$filedata);
			}else{
				$this->addHidden($field_filename,'');
				$this->addHidden($field_filedata,'');
			}
		}
		$fontsize=get_user_preferences('vpl_fontsize',12);
		$this->addHidden('fontsize',$fontsize);
		$param_tags .= vpl_param_tag('fontsize',$fontsize,true);
		$req_fgm = $this->vpl->get_required_fgm();
		$req_filelist =$req_fgm->getFileList();
		$min = count($req_filelist);
		$max = $this->instance->maxfiles;
		$param_tags .= vpl_editor_i18n::get_params_tag();
		$param_tags .= vpl_param_tag('minfiles',$min);
		$param_tags .= vpl_param_tag('maxfiles',$max);
		if($instance->restrictededitor){
			$param_tags .= vpl_param_tag('restrictededition');
		}
		$this->addHTML(vpl_get_editor_tag($param_tags));
		$this->addHTML(vpl_include_jsfile('editor.js'));
		//$mform->addElement('html',vpl_editor_i18n::add_jseditori18n(true));
		$i18n  = 'var changesNotSaved = "'.s(get_string('changesNotSaved',VPL)).'";';
		$i18n .= 'var fileNotChanged = "'.s(get_string('fileNotChanged',VPL)).'";';
		$i18n .= 'var filesNotChanged = "'.s(get_string('filesNotChanged',VPL)).'";';
		$i18n .= 'var filesChangedNotSaved = "'.s(get_string('filesChangedNotSaved',VPL)).'";';
		$this->addHTML(vpl_include_js($i18n));
		$this->addHTML(vpl_include_js('installCloseCheck();',true));
		$this->addHTML(vpl_include_js('initFiles('.$max.');',true));
	}
	function display(){
		print_box_start();
		parent::display();
		print_box_end();
	}
}


$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
if(!$vpl->is_submit_able()){
	print_error('nopermissions');
}
$userid = optional_param('userid',FALSE,PARAM_INT);
if(!$userid || $userid == $USER->id){//Edit own submission
	$userid = $USER->id;
	$vpl->require_capability(VPL_SUBMIT_CAPABILITY);
	$vpl->network_check();
	$vpl->password_check();
}
else { //Edit other user submission
	$vpl->require_capability(VPL_MANAGE_CAPABILITY);
}
//TODO full screen edition link_to_popup_window()
$vpl->add_to_log('edit submission', vpl_rel_url('forms/edition.php','id',$id,'userid',$userid));
$mform = new mod_vpl_editor_form('edition_process.php',$vpl);
$fullscreen=optional_param('fullscreen',0,PARAM_INT);
$iframe='<div id="div_er" style="display: none"></div>';
if($fullscreen){
	$vpl->print_header_simple('onload = "resizeApplet();"');
	$user = get_record('user','id',$userid);
	$nav = build_navigation(fullname($user),$vpl->get_course_module());
	echo '<div class="navbar clearfix">';
	echo '<div class="breadcrumb">';
	echo $nav['navlinks'];
	echo '</div>';
	echo '</div>';
	$mform->display();
	echo $iframe;
}else{
	//Display page
	$vpl->print_header(get_string('edition',VPL),false,'onload = "resizeApplet();"');
	$vpl->print_view_tabs(basename(__FILE__));
	$mform->display();
	echo $iframe;
}
$vpl->print_footer_simple();
?>
