<?php
/**
 * @version		$Id: filegroup_form.php,v 1.38 2010/01/19 17:47:52 juanca Exp $
 * @package		vpl. form to edit a group of files
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once $CFG->libdir.'/formslib.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../filegroup.class.php';
require_once dirname(__FILE__).'/../editor/editor_utility.php';

class mod_vpl_filegroup_form extends moodleform {
	protected $fgp;
	protected $page;
	protected $title;
	function __construct($page,$fgp, $title){
		$this->fgp = $fgp;
		$this->page = $page;
		$this->title = $title;
		parent::__construct($page);
	}
	function definition(){
		$mform    =& $this->_form;
		$filelist = $this->fgp->getFileList();
		//TODO Make ready for no javascript
		//Select form type
		$edit = optional_param('edit',-1,PARAM_INT);
		if($edit >=0 && $edit < count($filelist)){ //Editing file
			$mform->addElement('hidden','id');
			$mform->setType('id', PARAM_INT);
			$mform->setDefault('id',required_param('id',PARAM_INT));
			$mform->addElement('hidden','edit');
			$mform->setType('edit', PARAM_INT);
			$mform->setDefault('edit',required_param('edit',PARAM_INT));
			$htmladd = 'onclick="return readFile();"';
			$buttongroup = array();
			$buttongroup[] = $mform->createElement('submit','save',get_string('save',VPL),$htmladd);
			$buttongroup[] = $mform->createElement('submit','savecontinue',get_string('savecontinue',VPL),$htmladd);
			$buttongroup[] = $mform->createElement('submit','cancel',get_string('cancel'));
			$mform->addGroup($buttongroup);
			$fontsize=get_user_preferences('vpl_fontsize',12);
			$mform->addElement('hidden','fontsize');
			$mform->setDefault('fontsize',$fontsize);
			$mform->addElement('hidden','filename');
			$mform->setType('filename', PARAM_CLEANFILE);
			$mform->setDefault('filename',$filelist[$edit]);
			$mform->addElement('hidden','filedata');
			$mform->setType('filedata', PARAM_RAW);
			$mform->setDefault('filedata',$this->fgp->getFileData($edit));
		}
		else{ //File group editing
			$mform->addElement('header', 'header_filegroup', $this->title);
			$mform->addElement('hidden','id');
			$mform->setType('id', PARAM_INT);
			$mform->setDefault('id',required_param('id',PARAM_INT));
			$i = 0;
			foreach($filelist as $filename){
				$group = array();
				$ename = 'filename'.$i;
				$isstatic = $i< $this->fgp->get_numstaticfiles();
				$attributes = array();
				if($isstatic){
					$attributes['disabled'] = true;
				}
				$group[] = & $mform->createElement('text',$ename,'',$attributes);
				$group[] = & $mform->createElement('submit','edit'.$i,get_string('edit'));
				if(!$isstatic){
					$menssage = addslashes(get_string('delete_file_fq',VPL,$filename));
					$onclick ='onclick="return confirm(\''.$menssage.'\')"';
					$group[] = & $mform->createElement('submit','rename'.$i,get_string('rename'));
					$group[] = & $mform->createElement('submit','delete'.$i,get_string('delete'),$onclick);
				}
				$mform->addGroup($group,null, $this->fgp->getFileComment($i));
				if(!$isstatic){
					$mform->setType($ename,PARAM_CLEANFILE);
				}
				$mform->setDefault($ename,$filename);
				$i++;
			}
			if($this->fgp->get_maxnumfiles()> count($filelist)){
				$gnewfile = array();
				$gnewfile[] = & $mform->createElement('text','newfilename');
				$gnewfile[] = & $mform->createElement('submit','addfile',get_string('addfile',VPL));
				$mform->addGroup($gnewfile,null,get_string('addfile',VPL));
				$mform->setType('newfilename', PARAM_CLEANFILE);
			}
			//Error if fileupload in a addGroup element
			$mform->addElement('file','file',get_string('uploadfile',VPL));
			$mform->addElement('submit','uploadfile',get_string('uploadfile',VPL));
		}
	}
	function display(){
		parent::display();
		$edit = optional_param('edit',-1,PARAM_INT);
		$filelist = $this->fgp->getFileList();
		if($edit >= 0 && $edit < count($filelist)){ //Editing file
			//Generate editor
			$param_tags = vpl_param_tag('filename0',$filelist[$edit]);
			$param_tags .= vpl_param_tag('filedata0',$this->fgp->getFileData($edit));
			$param_tags .= vpl_editor_i18n::get_params_tag();
			$param_tags .= vpl_param_tag('minfiles','1');
			$param_tags .= vpl_param_tag('maxfiles','1');
			$fontsize=get_user_preferences('vpl_fontsize',12);
			$param_tags .= vpl_param_tag('fontsize',$fontsize,true);
			echo vpl_get_editor_tag($param_tags);
			echo vpl_include_jsfile('editor.js');
			echo vpl_include_js('initFile();resizeApplet();');
			$i18n  = 'var changesNotSaved = "'.s(get_string('changesNotSaved',VPL)).'";';
			$i18n .= 'var fileNotChanged = "'.s(get_string('fileNotChanged',VPL)).'";';
			$i18n .= 'var filesNotChanged = "'.s(get_string('filesNotChanged',VPL)).'";';
			echo vpl_include_js($i18n);
			echo vpl_include_js('installCloseCheck();',true);
		}else{
			$this->fgp->print_files();
		}
	}
	public function process(){
		$link=$this->page.'?id='.required_param('id',PARAM_INT);
		$fromform=$this->get_data();
		$mform    =& $this->_form;
		$filelist = $this->fgp->getFileList();
		$l = count($filelist);
		for($i =0 ; $i < $l ; $i++){
			$filename = 'filename'.$i;
			$rename = 'rename'.$i;
			$delete = 'delete'.$i;
			$confirmdelete = 'confirmdelete'.$i;
			$edit = 'edit'.$i;
			if(isset($fromform->$rename)){
				$name = basename($fromform->$filename);
				if($this->fgp->renameFile($i,$name)){
					$names = new stdClass;
					$names->from = $filelist[$i];
					$names->to = $name;
					vpl_redirect(get_string('filerenamed',VPL,$names),$link);
				}else{
					error(get_string('filenotrenamed',VPL,$filelist[$i]),$link);
				}
				return;
			}
			if(isset($fromform->$delete)){
				if($this->fgp->deleteFile($i)){
					vpl_redirect(get_string('filedeleted',VPL,$filelist[$i]),$link);
				}else{
					error(get_string('filenotdeleted',VPL,$filelist[$i]),$link);
				}
				return;
			}
			if(isset($fromform->$edit)){
				vpl_inmediate_redirect($this->page.'?id='.required_param('id',PARAM_INT).'&edit='.$i);
				return;
			}
		}
		if(isset($fromform->addfile)){
			if(isset($fromform->newfilename) && $fromform->newfilename>''){
				$name = basename($fromform->newfilename);
				if($this->fgp->addFile($name)){
					vpl_redirect(get_string('fileadded',VPL,$name),$link);
				}else{
					error(get_string('filenotadded',VPL),$link);
				}
				return;
			}
		}
		if(isset($fromform->uploadfile)){
			$file = $this->_form->getElement('file');
			if($file){
				$info = & $file->getValue();
				$name = basename($info['name']);
				if(!($name>'')){
					error(get_string('incorrect_file_name',VPL),$link);
				}
				if(array_search($name,$filelist)){
					$text=get_string('fileupdated',VPL,$name);
				}else{
					$text=get_string('fileadded',VPL,$name);
				}
				$data=$this->get_file_content('file');
				$encode = mb_detect_encoding($data, 'UNICODE, UTF-16, UTF-8, ISO-8859-1',true);
				if($encode > ''){ //If code detected
					$data = iconv($encode,'UTF-8',$data);
				}
				if($this->fgp->addFile($name, $data)){
					vpl_redirect($text,$link);
				}else{
					vpl_redirect(get_string('filenotadded',VPL),$link);
				}
			}
			else{
				vpl_redirect(get_string('filenotadded',VPL),$link);
			}
			return;
		}
		if(isset($fromform->save) || isset($fromform->savecontinue)){
			if($fontsize=optional_param('fontsize',FALSE)){
				set_user_preference('vpl_fontsize', $fontsize);
			}
			$num = required_param('edit',PARAM_INT);
			$filename = basename($fromform->filename);
			$data = urldecode(stripslashes($fromform->filedata));
			$this->fgp->addFile($filename,$data);
			if(isset($fromform->savecontinue)){
				vpl_redirect(get_string('savedfile',VPL,$filename),$link.'&amp;edit='.$num);
			}else{
				vpl_redirect(get_string('savedfile',VPL,$filename),$link);
			}
		}
		if(isset($fromform->cancel)){
			vpl_inmediate_redirect($link);
		}
		return;
	}
}


?>