<?php
/**
 * @version		$Id: index.php,v 1.21 2010/01/19 18:05:52 juanca Exp $
 * @package		vpl. List all instances in a course
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

function vpl_compare($a,$b){
	$ai = $a->get_instance();
	$bi = $b->get_instance();
	if($ai->automaticgrading != $bi->automaticgrading){
		return $ai->automaticgrading > $bi->automaticgrading;
	}
	if($ai->availablefrom == $bi->availablefrom){
		return $ai->name > $bi->name;
	}else{
		return $ai->availablefrom > $bi->availablefrom;
	}
}

require_once dirname(__FILE__).'/../../config.php';
require_once dirname(__FILE__).'/locallib.php';
$id = required_param('id', PARAM_INT);   // course
//Check course existence
if (! $course = get_record("course", "id", $id)) {
	print_error('invalidcourseid','',$id);
}

add_to_log($course->id, VPL, 'view all', "index.php?id=$course->id", '');
//Load strings
$strname  				= get_string('name');
$strvpls 				= get_string('modulenameplural',VPL);
$strshortdescription 	= get_string('shortdescription', VPL);
$strvisiblefrom			= get_string('visiblefrom', VPL);
$stravailablefrom		= get_string('availablefrom', VPL);
$strduedate				= get_string('duedate', VPL);
$strnopls 				= get_string('novpls', VPL);

$navlinks = array();
$navlinks[] = array('name' => $course->shortname, 'link' => vpl_abs_href('/course/view.php','id',$course->id), 'type' => 'course');
$navlinks[] = array('name' => $strvpls, 'link' => '', 'type' => 'activity');
$navigation = build_navigation($navlinks);

print_header($strvpls, $course->fullname, $navigation, '', '', false, '', navmenu($course));

//TODO list diferent for every instance

if (!$cms = get_coursemodules_in_course(VPL, $course->id,"m.shortdescription, m.visiblefrom, m.availablefrom, m.duedate")) {
	notice($strnopls, vpl_abs_href('/course/view.php','id',$course->id));
	die;
}
$timenow = time();
$table->head  = array ($strname, $strshortdescription,$strvisiblefrom,$stravailablefrom,$strduedate);
$table->align = array ('left', 'left', 'rigth', 'rigth', 'rigth');
$vpls = array();
//Get and select vpls to show
foreach ($cms as $cmid => $cm) {
	$vpl = new mod_vpl($cmid);
	if ($vpl->is_visible() && $vpl->has_capability(VPL_VIEW_CAPABILITY)) {
		$vpls[]=$vpl;
	}
}
uasort($vpls,'vpl_compare');
//Generate table
foreach ($vpls as $key => $vpl) {
	$instance = $vpl->get_instance();
	$url = vpl_rel_url('view.php','id',$vpl->get_course_module()->id);
	$table->data[] = array ("<a href='$url'>{$instance->name}</a>",
		$instance->shortdescription,
		$instance->visiblefrom>0?userdate($instance->visiblefrom):'',
		$instance->availablefrom>0?userdate($instance->availablefrom):'',
		$instance->duedate>0?userdate($instance->duedate):'');
}

echo "<br />";
print_table($table);
print_footer($course);

?>