/**
 * @version		$Id: editor.js,v 1.22 2010/01/19 17:53:15 juanca Exp $
 * @package		vpl. jscript functions to manage applet editor
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/
 
//For internationalization need the vars changesNotSaved, fileNotChanged, filesNotChanged
//TODO Add vpl_ to every var and function name
var vpl_fileName= new Array();
var vpl_fileData= new Array();

/**
 * When editing one file, this function get the initial filename
 * and data from the editor
*/
var getInfoAppletOK=1;
function initFile(){
  var ae = window.document.getElementById('appleteditorid');
  if(ae != null){
	  try{
		  vpl_fileName[0]=new String(ae.getFileName(0));
		  vpl_fileData[0]=new String(ae.getFileContent(0));
	  }
	  catch(e){
		  setTimeout('initFile()',250);
	  }
  }else{
	  setTimeout('initFile()',100);
  }
}

/**
 * When editing some files, this function get the initial filenames
 * and data from the editor
*/
function initFiles(max){
	  var ae = window.document.getElementById('appleteditorid');
  if(ae != null){
	  try{
		  for(i=0; i<max; i++){
			  vpl_fileName[i]=new String(ae.getFileName(i));
			  vpl_fileData[i]=new String(ae.getFileContent(i));
		  }
	  }
	  catch(e){
		  setTimeout('initFiles('+max+')',250);
	  }
  } else setTimeout('initFiles('+max+')',100);
}

/**
 * When editing one file, this function check data change
 * and set data in form fields
 */
function readFile(){
  var fm = window.document.getElementById('mform1');
  var ae = window.document.getElementById('appleteditorid');
  if(ae == null || fm == null){
	  alert('VPL: readFile() javascript error');
	  throw 'VPL: readFile() javascript error'; 
  }
  try{
	  newData = new String(ae.getFileContent(0));
	  previousData = new String(vpl_fileData[0]);
	  if(previousData.valueOf() == newData.valueOf()){
	     alert(fileNotChanged);
	     return false;
	  }else{
	     fm.filedata.value = newData;
	     fm.fontsize.value = ae.getFontSize();
	     vpl_fileData[0]=newData;
	  }
	  return true;
  }
  catch(e){
	  if(getInfoAppletOK){
		  alert('VPL: readFile() javascript error: '+e);
		  getInfoAppletOK=0;
	  }
	  return false;
  }
}

/**
* This function set edition target in form (XHTML restriction)
*/
function setETarget(){
  var fm = window.document.getElementById('mform1');
  var er= window.document.getElementById('div_er');
  if(er == null || fm == null){
	  alert('VPL: setETarget() javascript error');
	  throw 'VPL: setETarget() javascript error'; 
  }
  fm.target='edition_result';
  er.innerHTML='<iframe name="edition_result"></iframe>';	
}

/**
* When editing files, this function check if data change
* and set data in form fields
*/
function readFiles(){
  if(!filesChanged()){
     alert(filesNotChanged);
     return false;
  }
  var fm = window.document.getElementById('mform1');
  var ae = window.document.getElementById('appleteditorid');
  if(ae == null || fm == null){
	  alert('VPL: readFiles() javascript error');
	  throw 'VPL: readFiles() javascript error'; 
  }
  try{
	for(i=0; i<100; i++){
		 if(fm.elements['filename'+i]==null) break;
		 newName = new String(ae.getFileName(i));
		 fm.elements['filename'+i].value=newName;
		 vpl_fileName[i]=newName;
		 newData = new String(ae.getFileContent(i));
		 fm.elements['filedata'+i].value=newData;
		 vpl_fileData[i]=newData;
	}
    fm.fontsize.value = ae.getFontSize();
	return true;
  }
  catch(e){ //No access to applet
	if(getInfoAppletOK){
		alert('VPL: javascript using applet error');
		getInfoAppletOK=0;
	}
  	return false;
  }
}

/**
* This function check if data has changed
*/
function filesChanged(){
  var fm = window.document.getElementById('mform1');
  var ae = window.document.getElementById('appleteditorid');
  if(ae == null || fm == null){
	  alert('VPL: filesChanged() javascript error');
	  throw 'VPL: filesChanged() javascript error'; 
  }
  try{
	 if(fm.elements['filename'] != null){
	    newData = new String(ae.getFileContent(0));
	    return newData.valueOf() != vpl_fileData[0].valueOf();
	 }
     for(i=0; i<100; i++){
        newName = new String(ae.getFileName(i));
        if(fm.elements['filename'+i]==null &&
           newName.valueOf()==''){
           return false;
        }
        previousName = vpl_fileName[i];
        if(previousName == null){
        	previousName = new String('');
        }
        newData = new String(ae.getFileContent(i));
        previousData = vpl_fileData[i];
        if(previousData == null){
        	previousData = new String('');
        }
        //Check to break loop
        if(newName.valueOf() == '' && previousName.valueOf()=='' ){
        	return false;
        }
        if(newName.valueOf() != previousName.valueOf() ||
            previousData.valueOf() != newData.valueOf()){
           return true;
        }
     }
	 return false;
  }
  catch(e){ //No access to applet
	return false;
  }
}

/**
* This function alert if files in editor have change
*/
function alertFilesChanged(){
  if(filesChanged()){
     alert(filesChangedNotSaved);
  }
  return true;
}

/**
* This function install the checker to alert if going to leave the page
* and files have changed 
*/
function installCloseCheck(){
   window.onbeforeunload= function(){
      if(filesChanged()){
         return changesNotSaved;
      }
   }
}

/**
* This function resize the applet to greatest visible size 
*/
var appletWidth=0;
var appletHeight=0;
var resizeAppletOK=1;
function resizeApplet(){
	var offset=8; //Important, MS Explorer go into infinite loop if <8
	var page= window.document.getElementById('page');
	var applet=window.document.getElementById('appleteditorid');
	if(resizeAppletOK && (page == null || applet == null)){
		resizeAppletOK=0;
		alert('VPL: resizeApplet() javascript error');
		throw 'VPL: resizeApplet() javascript error'; 
	}
	try{
	    appletRec = applet.getBoundingClientRect();
	    pageRec = page.getBoundingClientRect();
	    var diffHeight=(pageRec.bottom-pageRec.top)-(appletRec.bottom-appletRec.top);
	    var newWidth=document.documentElement.clientWidth-2*appletRec.left;
	    var newHeight=document.documentElement.clientHeight-diffHeight-offset;
	    if(appletWidth!= newWidth || appletHeight != newHeight){
	        if(appletWidth< newWidth) newWidth -= offset;
	        if(appletHeight< newHeight) newHeight -= offset;
	        applet.width = newWidth;
	        applet.height  = newHeight;
	    	appletWidth= newWidth;
		    appletHeight= newHeight;
		    applet.setSize(newWidth,newHeight);
	    }
	}
	catch(e){ //No access to applet
		return;
	}
}
/**
* This set the resize controler
*/
window.onresize=resizeApplet;

