<?php
/**
 * @version		$Id: listsimilarity.php,v 1.10 2010/01/29 13:03:13 juanca Exp $
 * @package		vpl. List most similar submission files 
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
require_once dirname(__FILE__).'/similarity_factory.class.php';
require_once dirname(__FILE__).'/similarity_base.class.php';
require_once dirname(__FILE__).'/similarity_form.class.php';

$id = required_param('id', PARAM_INT);
$vpl = new mod_vpl($id);
$vpl->require_capability(VPL_SIMILARITY_CAPABILITY);
$vpl->add_to_log('view similarity', vpl_mod_href('similarity/similarity_form.php','id',$id));
//Print header
$vpl->print_header(get_string('listsimilarity',VPL));
$vpl->print_view_tabs(basename(__FILE__));
$form = new vpl_similarity_form('listsimilarity.php',$vpl);
if(!($fromform = $form->get_data())){
	print_error('readingdata',VPL);
}
//Get filelist names to scan
$filesselected=array();
$filelist = $vpl->get_required_fgm()->getFileList();
$num=0;
foreach($filelist as $filename){
	if(isset($fromform->{'file'.$num})){
		$filesselected[$filename]=true;
	}
	$num++;
}

$usernumber=0;
$nwm=0;
$simil = array();
//Preprocess current VPL instance
//TODO show the process and try to add time void set_time_limit  ( int $seconds  )
debugging("Adding activity files", DEBUG_DEVELOPER);
vpl_similarity::scan_activity($simil,$vpl,$filesselected);
debugging("Files to check ".count($simil), DEBUG_DEVELOPER);
$il = count($simil);
//Preprocess other VPL instance
if(isset($fromform->scanactivity) && $fromform->scanactivity>0){
	$othervpl=new mod_vpl($fromform->scanactivity);
	$othervpl->require_capability(VPL_SIMILARITY_CAPABILITY);
	debugging("Adding other activity files", DEBUG_DEVELOPER);
	vpl_similarity::scan_activity($simil,$othervpl,$filesselected);
	debugging("Files to check ".count($simil), DEBUG_DEVELOPER);
}
//Preprocess files in a ZIP file
if(isset($fromform->scanzipfile) && $fromform->scanzipfile>''){
	debugging("Adding files in zip file", DEBUG_DEVELOPER);
	vpl_similarity::scan_zip($simil,$fromform->scanzipfile,$vpl,$filesselected);
	debugging("Files to check ".count($simil), DEBUG_DEVELOPER);
}
//Preprocess files in a directory
if(isset($fromform->scandirectory) && $fromform->scandirectory>''){
	$basedir = $CFG->dataroot.'/'.$vpl->get_course()->id;
	debugging("Adding files in directory", DEBUG_DEVELOPER);
	vpl_similarity::scan_directory($simil,$basedir.'/'.$fromform->scandirectory,$filesselected);
	debugging("Files to check ".count($simil), DEBUG_DEVELOPER);
}
//Search similarity in other files after current VPL instance 
if(isset($fromform->searchotherfiles)){
	$il = count($simil);
}
$selected = vpl_similarity::get_selected($simil,$fromform->maxoutput,$il);

if(count($selected)){
	$firstname = get_string('firstname');
	$lastname  = get_string('lastname');
	if ($CFG->fullnamedisplay == 'lastname firstname') {
		$name = $lastname.' / '.$firstname;
	} else {
		$name = $firstname.' / '.$lastname;
	}
	$with	= get_string('similarto',VPL);
	$table = new stdClass();
	$table->head  = array ('#',$name, '',$with);
	$table->align = array ('rigth','left', 'center', 'left');
	$table->size = array ('','60','60');
	//Sort by similarity
	//krsort($selected);
	$usernumber=0;
	foreach($selected as $case){
		$usernumber++;
		$link=$case->comparation;
		if($case->first->can_access() && $case->second->can_access()){
			$url = vpl_mod_href('similarity/diff.php','id',$id);
			foreach($case->first->link_parms('1') as $parm => $value){
				$url = vpl_url_add_param($url,$parm,$value);
			}
			foreach($case->second->link_parms('2') as $parm => $value){
				$url = vpl_url_add_param($url,$parm,$value);
			}
			$link = link_to_popup_window($url,
					'viewsub'.$usernumber,
					$link,800,900,
					null,
					'location=1,status=1,scrollbars=1,toolbar=1,menubar=1,directories=1',true);
		}
		$table->data[] = array ($usernumber,
							$case->first->show_info(),
							$link,
							$case->second->show_info());
	}
	print_table($table);
}
/* debug code
$table->head  = array ('%','simility 1', 'simility 2');
$table->align = array ('right','right', 'right');
$table->size = array ('10','20','20');
$table->data=array();
for($i=0;$i<=100;$i++){
	$table->data[]=array($i,$dist1[$i],$dist2[$i]);
}
print_table($table);
*/
$vpl->print_footer();
?>