<?php
/**
 * @version		$Id: listwatermark.php,v 1.9 2010/01/19 17:59:27 juanca Exp $
 * @package		vpl. List water marks in vpl submission
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
require_once dirname(__FILE__).'/watermark.php';

$id = required_param('id', PARAM_INT);
$vpl = new mod_vpl($id);
$course = $vpl->get_course();
$vpl->require_capability(VPL_SIMILARITY_CAPABILITY);
$vpl->add_to_log('view watermarks', vpl_mod_href('similarity/listwatermark.php','id',$id));
//Print header
$vpl->print_header(get_string('listwatermarks',VPL));
$vpl->print_view_tabs(basename(__FILE__));
$list = get_users_by_capability($vpl->get_context(), 'moodle/legacy:student', '', "u.lastname ASC", '', '', '', '', false);
if($list == null){ //No users
	$vpl->print_footer();
	die;
}
//$list = get_course_students($course->id);
$firstname = get_string('firstname');
$lastname  = get_string('lastname');
if ($CFG->fullnamedisplay == 'lastname firstname') { // for better view (dlnsk)
	$name = $lastname.' / '.$firstname;
} else {
	$name = $firstname.' / '.$lastname;
}

//Load strings
$origin	= get_string('origin',VPL);
$table->head  = array ('#',$name, $origin);
$table->align = array ('rigth','left', 'left');
$table->size = array ('','60','60');
$submissions = $vpl->all_last_user_submission();
$usernumber=0;
$nwm=0;
foreach ($list as $userinfo) {
	if(isset($submissions[$userinfo->id])){
		$origin = '';
		$subinstance = $submissions[$userinfo->id];
		$submission = new mod_vpl_submission($vpl,$subinstance);
		$subf = $submission->get_submitted_fgm();
		$filelist = $subf->getFileList();
		foreach($filelist as $filename){
			$data = $subf->getFileData($filename);
			$wm = vpl_watermark::getwm($data);
			if($wm){
				if($wm != $userinfo->id){
					$user_origin = get_record('user','id',$wm);
					if($user_origin){
						$origin .='<a href="'.vpl_mod_href('/forms/submissionview.php','id',$id,'userid',$wm).'">';
						$origin .=s($filename).' ';
						$origin .= '</a>';
						$origin .=' <a href="'.vpl_abs_href('/user/view.php','id',$wm,'course',$course->id).'">';
						$origin .= fullname($user_origin).'</a>';
					}
				}else{
					$nwm++;
				}
			}
		}
		if($origin==''){
			continue;
		}
		$usernumber++;
		$table->data[] = array ($usernumber,print_user_picture($userinfo,$course->id,TRUE,FALSE,TRUE).' '.fullname($userinfo),
			$origin);
	}
}
if($usernumber>0){
	print_table($table);
}
print_box(get_string('nowatermark',VPL,$nwm));
$vpl->print_footer();
?>