<?php 
/**
 * @version		$Id: submissionslist.php,v 1.8 2010/01/19 18:03:53 juanca Exp $
 * @package		vpl. List student submissions of a VPL instances
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
$id = required_param('id', PARAM_INT);
$group = optional_param('group', -1, PARAM_INT);
$sort = optional_param('sort','lastname', PARAM_ALPHA);
$subselection = optional_param('selection','allsubmissions', PARAM_ALPHA);
$vpl = new mod_vpl($id);
$course = $vpl->get_course();
$cm = $vpl->get_course_module();
$context_module = $vpl->get_context();
$vpl->require_capability(VPL_GRADE_CAPABILITY);
$vpl->add_to_log('view all submissions', vpl_mod_href('index.php','id',$id), $vpl->get_instance()->name);
//Print header
$vpl->print_header(get_string('submissionslist',VPL));
$vpl->print_view_tabs(basename(__FILE__));
// find out current groups mode
$groupmode = groups_get_activity_groupmode($cm);
$currentgroup = groups_get_activity_group($cm, true);
//TODO review 
if ($currentgroup) {
	$list = get_users_by_capability($context_module, 'moodle/legacy:student', '', "u.$sort ASC", '', '', $currentgroup, '', false);
} else {
	$list = get_users_by_capability($context_module, 'moodle/legacy:student', '', "u.$sort ASC", '', '', '', '', false);
}
if($list == null){ //No user
	$vpl->print_footer();
	die;
}
$sort = $sort == 'firstname' ? 'firstname' : 'lastname';
$baseurl =vpl_mod_href('views/submissionslist.php','id',$id,'sort',$sort,'selection',$subselection);
 //Menu for groups
if ($groupmode == VISIBLEGROUPS) {
        groups_print_activity_menu($cm, $baseurl);
}
//Print user selection by submission state
echo '&nbsp;';
popup_form(vpl_mod_href('views/submissionslist.php','id',$id,'sort',$sort,'group',$group).'&amp;selection=',
			array('all' => get_string('all'), 'allsubmissions' => get_string('allsubmissions',VPL),'notgraded' => get_string('notgraded',VPL),
					'graded' => get_string('graded',VPL),'gradedbyuser' => get_string('gradedbyuser',VPL)), 
			'selectionmenu',
			$subselection, '', '', '', false, 'self', get_string('submissionselection',VPL));
echo '<br />';
@ob_flush();
flush();

//$list = get_course_students($course->id);
$firstname = '<a href="'.vpl_mod_href('views/submissionslist.php','id',$id,'group',$group,'sort','firstname').'">'.get_string('firstname').'</a>';
$lastname  = '<a href="'.vpl_mod_href('views/submissionslist.php','id',$id,'group',$group,'sort','lastname').'">'.get_string('lastname').'</a>';
if ($CFG->fullnamedisplay == 'lastname firstname') { // for better view (dlnsk)
	$namesortselect = $lastname.' / '.$firstname;
} else {
	$namesortselect = $firstname.' / '.$lastname;
}

//Load strings
$strsubtime 			= get_string('submittedon',VPL);
$strgrade				= get_string('grade');
$strgrader				= get_string('grader',VPL);
$strgradedon			= get_string('gradedon',VPL);
$gradeable=$vpl->get_instance()->grade != 0;
if($gradeable){
	$table->head  = array ('#',$namesortselect, $strsubtime,$strgrade,$strgrader,$strgradedon);
	$table->aling = array ('right','left', 'right','left','right','left');
}else{
	$table->head  = array ('#',$namesortselect, $strsubtime);
	$table->aling = array ('right','left', 'right');
}
$table->size = array ('','60','');

$vplname=$vpl->get_instance()->name.': ';
$submissions = $vpl->all_last_user_submission();
$usernumber=0;
$ngrades = array();
//Information to get next user in list
$next_ids = array();
$last_id=0;
foreach ($list as $userinfo) {
	if(!isset($submissions[$userinfo->id])){
		if($subselection != 'all'){
			continue;
		}
		$subtime = get_string('nosubmission',VPL);
		$grade ='';
		$grader ='';
		$gradedon ='';
	}
	else{
		$subinstance = $submissions[$userinfo->id];
		$submission = new mod_vpl_submission($vpl,$subinstance);
		$hrefview=vpl_mod_href('forms/submissionview.php','id',$id,
				'userid',$subinstance->userid,'inpopup',1);
		$hrefgrade=vpl_mod_href('forms/gradesubmission.php','id',$id,
				'userid',$subinstance->userid,'inpopup',1);
		$subtime = link_to_popup_window($hrefview,
					'viewsub'.$userinfo->id,
					userdate($subinstance->datesubmitted),600,800,
					null,
					'location=1,status=1,scrollbars=1,toolbar=1,menubar=1,directories=1',true);
	    $subid=$subinstance->id;
		if($subinstance->dategraded>0){
			if($subselection == 'notgraded'){
				continue;
			}
	    	if($subselection == 'gradedbyuser' && $subinstance->grader != $USER->id){
	    		continue;
	    	}
	    	$text = $submission->print_grade_core();
	    	$text = '<div id="g'.$subid.'">'.$text.'</div>';
	    	if($subinstance->grader == $USER->id){
	    		$grade = link_to_popup_window(	$hrefgrade,
	    									'gradesub'.$userinfo->id,
	    									$text,600,800,null,null,true);
	    		//Add new next user
				if($last_id){
					$next_ids[$last_id]=$userinfo->id;
				}
				$last_id=$subid; //Save submission id as next index
	    	}else{
	    		$grade = $text;
	    	}
	    	$graderid=$subinstance->grader;
	    	$graderuser = $submission->get_grader($graderid);
	    	//Count grader marks
	    	if(isset($ngrades[$graderid])){
	    		$ngrades[$graderid]++;
	    	}else{
	    		$ngrades[$graderid]=1;
	    	}
	    	$grader = fullname($graderuser); 
	    	$gradedon = userdate($subinstance->dategraded);
	    }else{
			if($subselection == 'graded' ||$subselection == 'gradedbyuser'){
				continue;
			}
	    	$result=$submission->getCE();
	    	$text='';
	    	if($result['executed']!==0){
	    		$prograde=$submission->proposedGrade($result['execution']);
	    		if($prograde>''){
	    			$text=get_string('proposedgrade',VPL,$submission->print_grade_core($prograde));
	    		}
	    	}
	    	if($text ==''){
	    		$text=get_string('nograde');
	    	}
	    	$text = '<div id="g'.$subid.'">'.$text.'</div>';
	    	$grade = link_to_popup_window(	$hrefgrade,
	    								'gradesub'.$userinfo->id,
	    								$text,600,800,null,null,true);
	    	$grader = '&nbsp;'; 
	    	$gradedon = '&nbsp;';
    		//Add new next user
			if($last_id){
				$next_ids[$last_id]=$userinfo->id;
			}
			$last_id=$subid; //Save submission id as next index
	    }
	    //Add div id to submission info
	    $grader ='<div id="m'.$subid.'">'.$grader.'</div>';
	    $gradedon ='<div id="o'.$subid.'">'.$gradedon.'</div>';
	}
	$usernumber++;
	if($gradeable){
		$table->data[] = array ($usernumber,print_user_picture($userinfo,$course->id,TRUE,FALSE,TRUE).' '.fullname($userinfo),
			$subtime,
			$grade,
			$grader,
			$gradedon);
	}else{
		$table->data[] = array ($usernumber,print_user_picture($userinfo,$course->id,TRUE,FALSE,TRUE).' '.fullname($userinfo),
			$subtime);
	}
}
if(count($ngrades)){
	if ($CFG->fullnamedisplay == 'lastname firstname') { // for better view (dlnsk)
		$namehead = get_string('lastname').' / '.get_string('firstname');
	} else {
		$namehead = get_string('firstname').' / '.get_string('lastname');;
	}
	
	$tablegraders->head  = array ('#',$namehead, $strgrade);
	$tablegraders->align = array ('right','left', 'center');
	$tablegraders->wrap = array ('nowrap','nowrap','nowrap');
	$tablegraders->data = array();
	$gradernumber=0;
	foreach($ngrades as $graderid => $marks){
		$gradernumber++;
		$grader = mod_vpl_submission::get_grader($graderid);
		$picture='';
		if($graderid>0){ //No automatic grading
			$picture = print_user_picture($grader,$course->id,TRUE,FALSE,TRUE);
		}
		$tablegraders->data[] = array($gradernumber,$picture.' '.fullname($grader),
										sprintf('%d/%d  (%5.2f%%)',$marks,$usernumber,(float)100.0*$marks/$usernumber));
	}
}
//Unblock user session
session_write_close();
echo '<br />';
print_table($table);
if(count($ngrades)>0){
	echo '<br />';
	print_table($tablegraders);
}
//Generate next info as <div id="submissionid">nextuser</div>
if(count($next_ids)){
	//Hide info
	echo '<div style="display:none;">';
	foreach($next_ids as $subid => $next_user){
		echo '<div id="n'.$subid.'">'.$next_user.'</div>';
	}
	echo '</div>';
}
$vpl->print_footer();
?>