<?php
/**
 * @version		$Id: vpl_submission_CE.class.php,v 1.17 2010/01/19 18:09:47 juanca Exp $
 * @package		vpl. submission Compilation Execution class definition
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/vpl_submission.class.php';
require_once dirname(__FILE__).'/jail/HTTP_request.class.php';
require_once dirname(__FILE__).'/jail/jailserver_manager.class.php';
require_once dirname(__FILE__).'/jail/proxy.class.php';
class mod_vpl_submission_CE extends mod_vpl_submission{
	/**
	 * Constructor
	 * @param $vpl object vpl instance
	 * @param $instance vpl submission
	 **/
	function __construct($vpl, $mix) {
		parent::__construct($vpl, $mix);
	}

	
	private $send_alive_count=0;
	
	/**
	 * Send update to the applet editor status bar
	 * @param $window
	 * @return void
	 */
	function send_alive_to_editor($window='window.parent'){
		echo str_pad('', 10000);
		echo vpl_include_js('try{updateStatusBarProcess('.$window.');}catch(e){}');
		echo '+';
		$this->send_alive_count++;
		if($this->send_alive_count % 40 == 0){
			echo '<br />';
		}
		@ob_flush();
		flush();
	}

	/**
	 * Send endStatusBarProcess to the applet editor status bar
	 * @param $window
	 * @return void
	 */
	function send_end_process($window='window.parent'){
		echo vpl_include_js('endStatusBarProcess('.$window.')');
		@ob_flush();
		flush();
	}
	
	/**
	 * Run, debug
	 * @param int $type (0=run, 1=debug)
	 */
	function run($type){
		//Caller Check security (who and config)
		global $CFG;
		$execute_scripts= array(0=>'vpl_run.sh',1=>'vpl_debug.sh',2=>'vpl_evaluate.sh');
		$data = $this->prepare_execution();
		$data->execute =$execute_scripts[$type];
		$data->interactive=0;
		$data->port=0;
		$data->password=0;
		$this->send_alive_to_editor();
		@ob_flush();
		$proxy = new vpl_doubleproxy($CFG->vpl_proxy_port_from,$CFG->vpl_proxy_port_to);
		$proxy->get_jail_info($jport,$jpass,$cport,$cpass);
		$data->interactive=1;
		$data->port=(int)$jport;
		$data->password=$jpass;
		$this->send_alive_to_editor();
		$limitTime = $data->maxtime; // save maxtime before manipulate $data
		//Select server
		$server = vpl_jailserver_manager::get_server($data->maxmemory);
		if($server == ''){
			$this->send_end_process();
			vpl_js_alert(get_string('nojailavailable',VPL));
			print_error('nojailavailable','',null,VPL);
			die;
		}
		$request = xmlrpc_encode_request('execute',$data,array('encoding'=>'UTF-8'));
		$http=new vpl_HTTP_request($request);
		$this->send_alive_to_editor();
		if(!$http->try_server($server)){
			$this->send_end_process();
			vpl_js_alert(get_string('serverexecutionerror',VPL));
			print_box($http->get_error());
			print_error('serverexecutionerror',VPL);
			die;
		}
		$go_on=true;
		$timeUpdateBar=time();
		$limitTime = 2*$limitTime + time(); //Limit time is 2(compilation+execution) * $data->maxtime
		while($go_on && time()<$limitTime){
			usleep(10000);
			if($timeUpdateBar!=time()){ //Every second
				$timeUpdateBar=time();
				$this->send_alive_to_editor();
			}
			$http->advance();
			$proxy->advance();
			$go_on= ($http->is_connected() || $proxy->is_running());
			//Check for jail and console conection timeout
			if($go_on && isset($resultSend)
				&& (!$proxy->is_jailconected() || !$proxy->is_clientconected())
				&& $jailConnectTimeOut< time()){
				$this->send_end_process();
				if(!$proxy->is_jailconected()){
					vpl_js_alert('Jail connection timeout');
				}
				if(!$proxy->is_clientconected()){
					vpl_js_alert('Console connection timeout');
				}
				break;
			}
			if(!$http->is_connected() && !isset($resultSend)){
				$resultSend = true;
				$jailConnectTimeOut = time()+6; //TODO reimplement
				if($http->get_state() == vpl_HTTP_request::error){
					$this->send_end_process();
					vpl_js_alert($http->get_error());
					debugging('http error '.$http->get_error());
					$proxy->close();
					return;
				} 
				$xml_response=$http->get_response();
				//Debug write XML to file
				//file_put_contents('/tmp/reponse_xmlrpc.txt',$xml_response);
				$response=xmlrpc_decode($xml_response,'UTF-8');
				if($response == null){
					$this->send_end_process();
					vpl_js_alert('xmlrpc_decode error');
					debugging('xmlrpc_decode error');
					$proxy->close();
					return;
				}elseif(xmlrpc_is_fault($response)){
					$this->send_end_process();
					vpl_js_alert($response['faultString']);
					debugging('xmlrpc error: '.$response['faultString']);
					$proxy->close();
					return;
				}
				//debug
				//p($xml_response);
				//p(print_r($response));
				$this->send_CE_to_editor($response);
				@ob_flush();
				flush();
				if(! $response['executed']){
					if($proxy->is_running()){
						$proxy->close();
					}
					$this->send_end_process();
					vpl_js_alert(get_string('notexecuted',VPL));
					break;
				}
				//Open console
				$script="window.parent.document.getElementById('appleteditorid').initConsole($cport,'$cpass');";
				echo vpl_include_js($script);
				@ob_flush();
				flush();
			}
		}
		if($http->is_connected()){
			$this->send_end_process();
			vpl_js_alert(get_string('httptimeout',VPL));
			$http->close_handles();
		}
		if($proxy->is_running()){
			$this->send_end_process();
			vpl_js_alert(get_string('proxytimeout',VPL).s(print_r($proxy,true)));
			$proxy->close();
		}
	}
	
	/**
	 * Evaluate submission.
	 * Save evaluation result and send information to the applet editor.
	 * If configured send grade and comments to the gradebook.
	 */
	function evaluate(){
		//Caller Check security (who and config)
		global $CFG;
		$data = $this->prepare_execution();
		$data->execute ='vpl_evaluate.sh';
		$data->interactive=0;
		$data->port=0;
		$data->password=0;
		$this->send_alive_to_editor();
		@ob_flush();
		$limitTime = $data->maxtime; // save maxtime before manipulate $data
		//Select server
		$server = vpl_jailserver_manager::get_server($data->maxmemory);
		if($server == ''){
			$this->send_end_process();
			vpl_js_alert(get_string('nojailavailable',VPL));
			print_error('nojailavailable',VPL);
			die;
		}
		$request = xmlrpc_encode_request('execute',$data,array('encoding'=>'UTF-8'));
		$http=new vpl_HTTP_request($request);
		$this->send_alive_to_editor();
		if(!$http->try_server($server)){
			$this->send_end_process();
			vpl_js_alert(get_string('serverexecutionerror',VPL));
			print_box($http->get_error());
			print_error('serverexecutionerror',VPL);
			die;
		}
		$timeUpdateBar=time();
		$limitTime = 2*$limitTime + time(); //Limit time is 2(compilation+execution) * $data->maxtime
		while(time()<$limitTime){
			usleep(10000);
			if($timeUpdateBar!=time()){
				$timeUpdateBar=time();
				$this->send_alive_to_editor();
			}
			$http->advance();
			if(!$http->is_connected()){
				if($http->get_state() == vpl_HTTP_request::error){
					$this->send_end_process();
					vpl_js_alert($http->get_error());
					debugging('http error '.$http->get_error());
					return;
				} 
				$xml_response=$http->get_response();
				//Debug write XML to file
				//file_put_contents('/tmp/reponse_xmlrpc.txt',$xml_response);
				$response=xmlrpc_decode($xml_response,'UTF-8');
				if($response == null){
					$this->send_end_process();
					vpl_js_alert('xmlrpc_decode error');
					//p($xml_response);
					debugging('xmlrpc_decode error');
					return;
				}elseif(xmlrpc_is_fault($response)){
					$this->send_end_process();
					vpl_js_alert($response['faultString']);
					debugging('xmlrpc error: '.$response['faultString']);
					return;
				}
				//debug
				//p($xml_response);
				//p(print_r($response));
				$this->send_CE_to_editor($response);
				$this->saveCE($response);
				
				if($response['executed']>0){
					//If automatic grading
					if($this->vpl->get_instance()->automaticgrading){
						$data = new StdClass;
						$data->grade = $this->proposedGrade($response['execution']);
						$data->comments = $this->proposedComment($response['execution']);;
						$this->set_grade($data,true);
					}
				}else{
					$this->send_end_process();
					vpl_js_alert(get_string('notexecuted',VPL));
				}
				break;
			}
		}
		if($http->is_connected()){
			$this->send_end_process();
			vpl_js_alert(get_string('httptimeout',VPL));
			$http->close_handles();
		}
	}
}
?>